#define _CRT_SECURE_NO_DEPRECATE
#include <float.h>
#define _USE_MATH_DEFINES
#include <math.h>

/* saturation pressure for water vapor in air */

double fPwsat(double T)
  {
  double f,x,y,z;
  x=(212.-T)/212.;
  y=((0.105846*x-5.28903)*x+9.2336)*x-4.20643;
  z=((-0.460382*x+2.03554)*x-2.55181)*x+1.;
  f=((((12.8616*x-48.4759)*x+70.0633)*x-46.5043)*x+12.9658)*x;
  return(14.696*exp(x*y/z)*(1.+0.005*f));
  }

/* absolute humidity of moist air at saturation */

double fWsat(double Pabs,double T)
  {
  double ps;
  ps=fPwsat(T);
  return((18.01534/28.9645)*ps/(Pabs-ps));
  }

/* absolute humidity from dry-bulb & relative humidity */

double fWdbrh(double Pabs,double Tdb,double RH)
  {
  double dp,pg,pv;
  if(RH>=1.)
    return(fWsat(Pabs,Tdb));
  pg=fPwsat(Tdb);
  pv=pg*RH;
  dp=Pabs-pv;
  if(dp<0.01)
    dp=0.01;
  return((18.01534/28.9645)*pv/dp);
  }
